﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using PaymentBackend.Context;

namespace PaymentBackend.Migrations
{
    [DbContext(typeof(PaymentContext))]
    [Migration("20191003211849_AddOverdraftToAccount")]
    partial class AddOverdraftToAccount
    {
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "2.2.6-servicing-10079")
                .HasAnnotation("Relational:MaxIdentifierLength", 64);

            modelBuilder.Entity("PaymentBackend.Entities.Account", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<decimal>("Balance")
                        .ValueGeneratedOnAdd()
                        .HasDefaultValue(0.0m);

                    b.Property<string>("CardId");

                    b.Property<bool>("Locked");

                    b.Property<int>("Overdraft");

                    b.Property<string>("Password")
                        .IsRequired();

                    b.Property<string>("PasswordSalt")
                        .IsRequired();

                    b.Property<string>("Username")
                        .IsRequired();

                    b.HasKey("Id");

                    b.HasIndex("CardId")
                        .IsUnique();

                    b.HasIndex("Username")
                        .IsUnique();

                    b.ToTable("Accounts");

                    b.HasData(
                        new
                        {
                            Id = new Guid("de89dcc7-f39f-41d2-9900-1df0bd440ed9"),
                            Balance = 0.0m,
                            Locked = false,
                            Overdraft = 0,
                            Password = "bf8cb09310e40a1857562adca4f612502b35bbb5ad46900b825a3fdc0d6c9fbf",
                            PasswordSalt = "f2361a6be65a5313b83e9d6e8a165f21",
                            Username = "admin"
                        });
                });

            modelBuilder.Entity("PaymentBackend.Entities.AccountRole", b =>
                {
                    b.Property<Guid>("AccountId");

                    b.Property<Guid>("RoleId");

                    b.HasKey("AccountId", "RoleId");

                    b.HasIndex("RoleId");

                    b.ToTable("AccountRoles");

                    b.HasData(
                        new
                        {
                            AccountId = new Guid("de89dcc7-f39f-41d2-9900-1df0bd440ed9"),
                            RoleId = new Guid("334b3221-4d17-445e-9b75-317868a161ff")
                        });
                });

            modelBuilder.Entity("PaymentBackend.Entities.PointOfSale", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("Name")
                        .IsRequired();

                    b.HasKey("Id");

                    b.HasIndex("Name")
                        .IsUnique();

                    b.ToTable("PointsOfSale");
                });

            modelBuilder.Entity("PaymentBackend.Entities.Product", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("Description");

                    b.Property<string>("Image");

                    b.Property<string>("Name")
                        .IsRequired();

                    b.Property<int>("Order");

                    b.Property<decimal>("Price");

                    b.Property<Guid>("ProductTypeId");

                    b.HasKey("Id");

                    b.HasIndex("Name")
                        .IsUnique();

                    b.HasIndex("ProductTypeId");

                    b.ToTable("Products");
                });

            modelBuilder.Entity("PaymentBackend.Entities.ProductType", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("Name")
                        .IsRequired();

                    b.HasKey("Id");

                    b.HasIndex("Name")
                        .IsUnique();

                    b.ToTable("ProductTypes");
                });

            modelBuilder.Entity("PaymentBackend.Entities.PurchaseTransactionEntry", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<decimal>("Price");

                    b.Property<Guid>("ProductId");

                    b.Property<Guid>("PurchaseTransactionId");

                    b.HasKey("Id");

                    b.HasIndex("ProductId");

                    b.HasIndex("PurchaseTransactionId");

                    b.ToTable("PurchaseTransactionEntries");
                });

            modelBuilder.Entity("PaymentBackend.Entities.Role", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<string>("Name")
                        .IsRequired();

                    b.HasKey("Id");

                    b.ToTable("Roles");

                    b.HasData(
                        new
                        {
                            Id = new Guid("334b3221-4d17-445e-9b75-317868a161ff"),
                            Name = "Admin"
                        },
                        new
                        {
                            Id = new Guid("525d09dd-ceea-4851-a7cd-8223c4c24689"),
                            Name = "User"
                        },
                        new
                        {
                            Id = new Guid("bfd373c2-c652-4f43-9f3d-d9cdd0b4ceb8"),
                            Name = "NfcClient"
                        },
                        new
                        {
                            Id = new Guid("c5ccdf94-bc36-42f2-9e5f-5a1a22bb6360"),
                            Name = "CashDesk"
                        });
                });

            modelBuilder.Entity("PaymentBackend.Entities.Transaction", b =>
                {
                    b.Property<Guid>("Id")
                        .ValueGeneratedOnAdd();

                    b.Property<Guid>("AccountId");

                    b.Property<DateTime?>("Cancelled");

                    b.Property<string>("Comment");

                    b.Property<string>("Discriminator")
                        .IsRequired();

                    b.Property<Guid>("PointOfSaleId");

                    b.Property<decimal>("Sum");

                    b.Property<DateTime>("Timestamp");

                    b.HasKey("Id");

                    b.HasIndex("AccountId");

                    b.HasIndex("PointOfSaleId");

                    b.ToTable("Transactions");

                    b.HasDiscriminator<string>("Discriminator").HasValue("Transaction");
                });

            modelBuilder.Entity("PaymentBackend.Entities.ChargeTransaction", b =>
                {
                    b.HasBaseType("PaymentBackend.Entities.Transaction");

                    b.ToTable("ChargeTransactions");

                    b.HasDiscriminator().HasValue("ChargeTransaction");
                });

            modelBuilder.Entity("PaymentBackend.Entities.PurchaseTransaction", b =>
                {
                    b.HasBaseType("PaymentBackend.Entities.Transaction");

                    b.ToTable("PurchaseTransactions");

                    b.HasDiscriminator().HasValue("PurchaseTransaction");
                });

            modelBuilder.Entity("PaymentBackend.Entities.AccountRole", b =>
                {
                    b.HasOne("PaymentBackend.Entities.Account", "Account")
                        .WithMany("Roles")
                        .HasForeignKey("AccountId")
                        .OnDelete(DeleteBehavior.Cascade);

                    b.HasOne("PaymentBackend.Entities.Role", "Role")
                        .WithMany()
                        .HasForeignKey("RoleId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("PaymentBackend.Entities.Product", b =>
                {
                    b.HasOne("PaymentBackend.Entities.ProductType", "ProductType")
                        .WithMany()
                        .HasForeignKey("ProductTypeId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("PaymentBackend.Entities.PurchaseTransactionEntry", b =>
                {
                    b.HasOne("PaymentBackend.Entities.Product", "Product")
                        .WithMany()
                        .HasForeignKey("ProductId")
                        .OnDelete(DeleteBehavior.Cascade);

                    b.HasOne("PaymentBackend.Entities.PurchaseTransaction", "PurchaseTransaction")
                        .WithMany("Entries")
                        .HasForeignKey("PurchaseTransactionId")
                        .OnDelete(DeleteBehavior.Cascade);
                });

            modelBuilder.Entity("PaymentBackend.Entities.Transaction", b =>
                {
                    b.HasOne("PaymentBackend.Entities.Account", "Account")
                        .WithMany()
                        .HasForeignKey("AccountId")
                        .OnDelete(DeleteBehavior.Cascade);

                    b.HasOne("PaymentBackend.Entities.PointOfSale", "PointOfSale")
                        .WithMany()
                        .HasForeignKey("PointOfSaleId")
                        .OnDelete(DeleteBehavior.Cascade);
                });
#pragma warning restore 612, 618
        }
    }
}
